<?php
ini_set('display_errors', 1);

require_once '../../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . '/user_management/check_username_availability.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'admin_api/academic_session/functions/registration_functions.php';
require_once $base_path_to_learning . 'admin_api/modules/students/student_functions.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//dynemic db
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

require_once $base_path_to_learning . "vendor/autoload.php";
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';

use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;

$postdata = json_decode(file_get_contents("php://input"), true);

if (
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type']) or
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['jwt_token']) or !checkIfIssetAndNotEmpty($postdata['jwt_token']) or
    !isset($postdata['institution_id']) or !checkIfIssetAndNotEmpty($postdata['institution_id'])
) {
    errorreturn("All * fields are required.");
}

validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id,['superadmin','admin'],null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

function GetBasicFacultyDetail($conn_rjllearning_specific, $institution_id, $branch_id, $date)
{
    try {
        // Build the SQL query
        $sql = "SELECT f.id, f.name,  f.designation, d.value ,f.role
                FROM faculty_info f
                LEFT JOIN staff_attendance_daywise d ON f.id = d.user_id AND d.date = ?
                WHERE f.institution_id = ? AND f.branch_id = ? AND f.role IN ('teacher','other','principal') AND f.status = ? 
                ORDER BY f.name ASC, f.father_name ASC, f.id ASC";

        // Prepare the statement
        $stmt = $conn_rjllearning_specific->prepare($sql);

        // Bind parameters and execute the query
        $stmt->execute([$date, $institution_id, $branch_id,  1]);

        // Fetch the results
        $result = $stmt->fetchAll();
     

        // Return the result

        $newArray = array();

        foreach ($result as $item) {

            $newArray[] = array(
                'faculty_id' => $item['id'],
                'name' => $item['name'],
                 'role' => $item['role'],
                'designation' => $item['designation'],
                'value' => $item['value']
            );
        }
        return $newArray;
    } catch (PDOException $e) {
        errorreturn("Error executing query: " . $e->getMessage());
    }
}
if ($postdata['function_type']  == "faculty_list") {


    if (isset($postdata['branch_id']) and !empty($postdata['branch_id']) and trim($postdata['branch_id'])) {
        $branch_id = trim($postdata['branch_id']);
    } else {
        $branch_id = "all";
    }

    $date = isset($postdata['date']) ? $postdata['date'] : date('Y-m-d');

    $institution_id = trim($postdata['institution_id']);
    $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
    if ($check_academic_confirmation != true) {
        errorreturn("Access denied. Academic session not active.");
    }

    $success['data'] = GetBasicFacultyDetail($conn_rjllearning_specific, $institution_id, $branch_id, $date);
    successreturn($success);
}
